env:
  node: true
  es6: true
extends:
  - 'plugin:@typescript-eslint/recommended'
  - 'plugin:@typescript-eslint/recommended-requiring-type-checking'
  - 'plugin:security/recommended'
globals:
  Atomics: readonly
  SharedArrayBuffer: readonly
  document: true
parser: '@typescript-eslint/parser'
parserOptions:
  ecmaVersion: 2020
  project: ./**/tsconfig.json
  sourceType: module
  ecmaFeatures:
    jsx: true
plugins:
  - '@typescript-eslint'
  - jest
  - prefer-arrow
  - security
  - no-unsanitized
rules:
  '@typescript-eslint/adjacent-overload-signatures': error
  '@typescript-eslint/await-thenable': warn
  '@typescript-eslint/array-type': off
  '@typescript-eslint/ban-ts-ignore': off
  '@typescript-eslint/ban-types': error
  '@typescript-eslint/consistent-type-assertions': error
  '@typescript-eslint/consistent-type-definitions': error
  '@typescript-eslint/explicit-function-return-type': off
  '@typescript-eslint/explicit-member-accessibility':
    - off
    - accessibility: explicit
  indent:
    - error
    - 2
    - SwitchCase: 1
  '@typescript-eslint/interface-name-prefix': off
  '@typescript-eslint/member-ordering': off
  '@typescript-eslint/naming-convention':
      - error
      - selector: typeLike
        format:
          - PascalCase
  '@typescript-eslint/no-empty-function': error
  '@typescript-eslint/no-empty-interface': off
  '@typescript-eslint/no-explicit-any': off
  '@typescript-eslint/no-inferrable-types': error
  '@typescript-eslint/no-misused-new': error
  '@typescript-eslint/no-namespace': error
  '@typescript-eslint/no-shadow': warn
  '@typescript-eslint/no-parameter-properties': off
  '@typescript-eslint/no-unused-vars': off
  # '@typescript-eslint/no-unused-vars-experimental': warn
  '@typescript-eslint/no-use-before-define': off
  '@typescript-eslint/no-var-requires': off
  '@typescript-eslint/no-unnecessary-type-assertion': warn
  '@typescript-eslint/prefer-for-of': error
  '@typescript-eslint/prefer-function-type': error
  '@typescript-eslint/prefer-namespace-keyword': error
  '@typescript-eslint/quotes':
    - error
    - single
  '@typescript-eslint/restrict-template-expressions': off
  '@typescript-eslint/semi':
    - off
    - multiline:
      delimiter: none
      requireLast: true
    - singleline:
      delimiter: semi
      requireLast: false
  '@typescript-eslint/triple-slash-reference': error
  '@typescript-eslint/type-annotation-spacing': error
  '@typescript-eslint/unified-signatures': error
  '@typescript-eslint/require-await': warn
  'arrow-body-style': warn
  arrow-parens:
    - off
    - as-needed
  camelcase: warn
  comma-dangle: off
  complexity: off
  constructor-super: error
  curly: off
  dot-notation: error
  eol-last: off
  eqeqeq:
    - error
    - smart
  guard-for-in: error
  id-blacklist: error
  id-match: error
  import/order: off
  max-classes-per-file:
    - error
    - 1
  max-len:
    - warn
    - code: 140
  new-parens: error
  no-bitwise: error
  no-caller: error
  no-cond-assign: error
  no-console:
    - error
    - allow:
        - log
        - error
        - warn
        - dir
        - timeLog
        - assert
        - clear
        - count
        - countReset
        - group
        - groupEnd
        - table
        - dirxml
        - groupCollapsed
        - Console
        - profile
        - profileEnd
        - timeStamp
        - context
  no-debugger: error
  no-empty: error
  no-eval: error
  no-fallthrough: error
  no-invalid-this: off
  no-multiple-empty-lines: error
  no-new-wrappers: error
  no-redeclare: error
  no-shadow: off
  no-throw-literal: error
  no-trailing-spaces: error
  no-undef-init: error
  no-underscore-dangle: warn
  no-unsafe-finally: error
  no-unused-expressions: off
  no-unused-labels: error
  no-var: error
  object-shorthand: error
  one-var:
    - off
    - never
  prefer-arrow/prefer-arrow-functions: warn
  prefer-const: error
  quote-props:
    - error
    - consistent-as-needed
  radix: error
  space-before-function-paren:
    - error
    - anonymous: never
      asyncArrow: always
      named: never
  spaced-comment:
    - off
    - never
  use-isnan: error
  valid-typeof: off
  no-async-promise-executor: off
  no-unused-vars: off
  linebreak-style: 0
  quotes:
    - error
    - single
  semi:
    - error
    - never
  max-depth:
    - warn
    - 5
  security/detect-buffer-noassert: error
  security/detect-child-process: error
  security/detect-disable-mustache-escape: error
  security/detect-eval-with-expression: error
  security/detect-new-buffer: error
  security/detect-no-csrf-before-method-override: error
  security/detect-non-literal-fs-filename: error
  security/detect-non-literal-regexp: error
  security/detect-non-literal-require: error
  security/detect-possible-timing-attacks: error
  security/detect-pseudoRandomBytes: error
  security/detect-unsafe-regex: error
  no-unsanitized/method: error
  no-unsanitized/property: error
